#!/usr/bin/python
# -*- coding: UTF-8 -*-

###############################################################
#一个经销商要访问6个城市，问有多少种访问的顺序
#Version : 1.0.0.1
#usage : 
#
#
###############################################################

import sys
import os

total_visit_order_num = 0

def list_is_in_order(number_list):
    for i in range(len(number_list) - 1):
        if number_list[i] < number_list[i + 1]:
            return  False
    return  True

def find_no_order_index(num_list):
    for i in range(len(num_list) - 1, 0, -1):
        if num_list[i] > num_list[i - 1]:
            return i - 1

def find_min_max_index(number_list, index = 0):
    if index >= len(number_list) - 1:
        return

    for i in range(index, len(number_list) - 1):
        #find a_j < a_j+1
        if number_list[i] < number_list[i + 1]:
            #check if a_j+1 > a_j+2 > a_j+3 ...
            if list_is_in_order(number_list[i + 1 :]):
                return i

def find_bigger_index(num_list, num_index):
    bigger = max(num_list)
    index = num_index + 1
    i = index
    while i < len(num_list):
        item = num_list[i]
        if item > num_list[num_index]:
            if item <= bigger:
                bigger = item
                index = i
        i += 1

    return  index

def sort_num_list(num_list, index):
    head_list = num_list[ : index + 1]
    tail_list = num_list[(index + 1) :]
    tail_list.sort()
    #tail_list.reverse()
    return head_list + tail_list

def recursion_number_order(number_list):
    print number_list
    global total_visit_order_num
    total_visit_order_num += 1
    #a = find_min_max_index(number_list)
    a = find_no_order_index(number_list)
    
    if None == a:
        return
    else:
        bigger_index = find_bigger_index(number_list, a)
        #exchange a and bigger
        temp = number_list[a]
        number_list[a] = number_list[bigger_index]
        number_list[bigger_index] = temp
        number_list = sort_num_list(number_list, a)
        recursion_number_order(number_list)

def visit_order(visit_citys):
    visit_citys = range(len(visit_citys))
    recursion_number_order(visit_citys)


def recursion_visit_order(visit_citys, index = 0):
    """in visit_citys, index : city number, value : visit index, if not visited, visit index is -1"""
    #index = visit index
    visited_num = 0
    for i, city in enumerate(visit_citys):
        if -1 == city:
            new_visit_citys = list(visit_citys)
            new_visit_citys[i] = index
            recursion_visit_order(new_visit_citys, index + 1)
        else:
            visited_num += 1

    #if all city is visited, print the visit order
    if visited_num == len(visit_citys):
        global total_visit_order_num
        total_visit_order_num += 1
        print visit_citys

############################# main ##################################
if __name__ == '__main__':
    visit_citys = [-1] * 5
    #recursion_visit_order(visit_citys)
    visit_order(visit_citys)
    #print find_no_order_index([0, 4, 3, 2, 1])
    #print sort_num_list([1, 2, 3, 5, 0, 4], 2)
    #print find_bigger_index([0, 1, 3, 2, 5], 3)
    print "total visit city order number :", total_visit_order_num    